<template lang="pug">
	article#categoria

		header( v-if="categoria" )
			hgroup
				h1 Categoria: {{ categoria.nombre | capitalizar }}



			.operaciones
				button( type='button', @click="subir", v-tooltip="'Subir'").subir
					vector(src="~@img/ico-subir.svg?inline")
			//-.columnas
				.columna: h2 Archivo
				.columna: h2 Usuario
				.columna: h2 Acciones
		listado

		section.detalle
			detalleArchivo( v-if="archivo", :archivo="archivo" )
</template>

<script>
	import Listado from "@/components/Listado";
	import DetalleArchivo from "@/components/DetalleArchivo";
	import { mapState, mapActions, mapMutations } from "vuex";

	export default {
		name: "Categoria",
		components: {
			Listado,
			DetalleArchivo
		},
		watch: {
			id(n, a) {
				if (this.id) {
					this.obtenerCategoria({ id: this.id });
					this.$el.scrollIntoView({
						behavior: "smooth",
						block: "start"
					});
				}
			}
		},
		computed: {
			id() {
				return this.$route.params.id || this.disco.id;
			},
			...mapState(["categoria", "archivos", "archivo", "disco"])
		},
		methods: {
			subir() {
				//alert("subir");
				this.$root.$emit("archivo-subir");
			},
			...mapActions(["obtenerArchivos", "obtenerCategoria"])
		},
		created() {
			console.log("categoria", this.id);
			this.obtenerCategoria({ id: this.id });
			this.$root.$on("archivo-actualizado", () => {
				this.obtenerCarpeta({ id: this.id, actualiza: true });
			});
		}
	};
</script>

<style lang="stylus" scoped>
	@import "~nib/index"
	@import "../stylus/base/utiles.styl"

	#categoria
		display grid
		grid-template-areas "encabezado detalle" "listado detalle"
		grid-template-columns 1fr max-content
		grid-template-rows min-content 1fr
		grid-gap 0 1rem
		align-content start
		align-items start

	header
		grid-area encabezado
		display grid
		justify-content stretch
		justify-items stretch
		grid-template-areas "titulo titulo" "ruta acciones" "columnas ."
		grid-template-columns 25fr min-content
		grid-gap 0 1rem
		border-bottom 1px solid tint( azul, 60% )
		margin-bottom 1rem
		background-color fondo_listado
		border-radius .5rem .5rem 0 0

		hgroup
			grid-area titulo
			background-color azul
			color white
			padding .8rem 1rem
			display flex
			border-radius .5rem .5rem 0 0

			h1
				font-weight 500
				line-height 1
				font-size calcRem( 15 )

		nav
			display flex
			align-items center
			justify-content space-between
			padding .8rem 1rem
			line-height 1

			.ruta
				display flex

				// TODO: Optimizar esta parte
				span
					margin-right .5em
					font-size calcRem( 12 )
					color tint( azul, 55% )
					word-wrap normal
					white-space nowrap

				a
					text-decoration none
					margin-right .5em
					font-size calcRem( 12 )
					color tint( azul, 40% )
					display block
					word-wrap normal
					white-space nowrap

					&::after
						content ""
						margin-left .5em
						border-top 4px solid transparente
						border-bottom 4px solid transparente
						border-left 5px solid tint( azul, 60% )
						width 0
						height 0
						display inline-block
						vertical-align middle

		.operaciones
			font-size .75rem
			width auto // 20vw
			box-sizing border-box
			display flex
			justify-content flex-end
			align-items center

			button
				padding .5rem
				margin 0 .2rem
				border none
				background-color transparente
				color lighten( negro, 40% )
				border-radius 2rem
				cursor pointer

				&:hover
					background-color alpha( silver, 25% )
					color tint( azul, 20% )

				.vector
					width 24px
					height 24px

		.columnas
			display flex
			justify-content space-between
			align-items center
			padding 1rem .5rem

			.columna
				color lighten( negro, 40% )
				flex 2 1 30%

				&:first-child
					flex 2 1 40%

				&:last-child
					flex 0 0 200px

				h2
					margin 0 .5rem
					font-size calcRem( 12 )
					font-weight 500

	.listado
		grid-area listado
		background-color fondo_listado

	.detalle
		grid-area detalle
		margin 0
</style>
